using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using SmartDeviceMap.Map;
using System.Net;
using Microsoft.WindowsMobile.Samples.Location;
using Microsoft.WindowsMobile.PocketOutlook;
using System.Data.SqlServerCe;
using System.Data.SqlClient;
using System.Threading;
using System.Web;



namespace SmartDeviceMap
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private System.Windows.Forms.MainMenu mainMenu1;

        private EventHandler updateDataHandler;
        GpsDeviceState device = null;
        GpsPosition position = null;
        private wheretodoDataSet wheretodoDataSet;
        private BindingSource wheretodoDataSetBindingSource;
        private System.ComponentModel.IContainer components;
        private BindingSource wheretodoDataSetBindingSource1;
        private TabPage tabPage6;
        private TabPage tabPage5;
        private Button button2;
        private Label label14;
        private DateTimePicker dateTimePicker2;
        private ComboBox comboBox1;
        private TextBox textBox2;
        private TextBox textBox1;
        private DateTimePicker dateTimePicker1;
        private Button button1;
        private Label label13;
        private Label label12;
        private Label label11;
        private Label label10;
        private TabPage status12;
        private Label status;
        private TabControl tcMap;
        private TextBox inputdistance;
        private Label label1;

        
        Gps gps = new Gps();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
            updateDataHandler = new EventHandler(UpdateData);

            status.Text = "";

            gps.DeviceStateChanged += new DeviceStateChangedEventHandler(gps_DeviceStateChanged);
            gps.LocationChanged += new LocationChangedEventHandler(gps_LocationChanged);

            gps.Open();
		}
	
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.mainMenu1 = new System.Windows.Forms.MainMenu();
            this.wheretodoDataSet = new SmartDeviceMap.wheretodoDataSet();
            this.wheretodoDataSetBindingSource = new System.Windows.Forms.BindingSource(this.components);
            this.wheretodoDataSetBindingSource1 = new System.Windows.Forms.BindingSource(this.components);
            this.tabPage6 = new System.Windows.Forms.TabPage();
            this.inputdistance = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.tabPage5 = new System.Windows.Forms.TabPage();
            this.button2 = new System.Windows.Forms.Button();
            this.label14 = new System.Windows.Forms.Label();
            this.dateTimePicker2 = new System.Windows.Forms.DateTimePicker();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.textBox2 = new System.Windows.Forms.TextBox();
            this.textBox1 = new System.Windows.Forms.TextBox();
            this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
            this.button1 = new System.Windows.Forms.Button();
            this.label13 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.status12 = new System.Windows.Forms.TabPage();
            this.status = new System.Windows.Forms.Label();
            this.tcMap = new System.Windows.Forms.TabControl();
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSet)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSetBindingSource)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSetBindingSource1)).BeginInit();
            this.tabPage6.SuspendLayout();
            this.tabPage5.SuspendLayout();
            this.status12.SuspendLayout();
            this.tcMap.SuspendLayout();
            this.SuspendLayout();
            // 
            // wheretodoDataSet
            // 
            this.wheretodoDataSet.DataSetName = "wheretodoDataSet";
            this.wheretodoDataSet.Prefix = "";
            this.wheretodoDataSet.SchemaSerializationMode = System.Data.SchemaSerializationMode.IncludeSchema;
            // 
            // wheretodoDataSetBindingSource
            // 
            this.wheretodoDataSetBindingSource.DataSource = this.wheretodoDataSet;
            this.wheretodoDataSetBindingSource.Position = 0;
            this.wheretodoDataSetBindingSource.CurrentChanged += new System.EventHandler(this.wheretodoDataSetBindingSource_CurrentChanged);
            // 
            // wheretodoDataSetBindingSource1
            // 
            this.wheretodoDataSetBindingSource1.DataSource = this.wheretodoDataSet;
            this.wheretodoDataSetBindingSource1.Position = 0;
            // 
            // tabPage6
            // 
            this.tabPage6.Controls.Add(this.inputdistance);
            this.tabPage6.Controls.Add(this.label1);
            this.tabPage6.Location = new System.Drawing.Point(0, 0);
            this.tabPage6.Name = "tabPage6";
            this.tabPage6.Size = new System.Drawing.Size(232, 222);
            this.tabPage6.Text = "Settings";
            // 
            // inputdistance
            // 
            this.inputdistance.Location = new System.Drawing.Point(146, 36);
            this.inputdistance.Name = "inputdistance";
            this.inputdistance.Size = new System.Drawing.Size(27, 21);
            this.inputdistance.TabIndex = 1;
            this.inputdistance.Text = "40";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(18, 36);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(137, 34);
            this.label1.Text = "Distance from POI for alert (km):";
            // 
            // tabPage5
            // 
            this.tabPage5.Controls.Add(this.button2);
            this.tabPage5.Controls.Add(this.label14);
            this.tabPage5.Controls.Add(this.dateTimePicker2);
            this.tabPage5.Controls.Add(this.comboBox1);
            this.tabPage5.Controls.Add(this.textBox2);
            this.tabPage5.Controls.Add(this.textBox1);
            this.tabPage5.Controls.Add(this.dateTimePicker1);
            this.tabPage5.Controls.Add(this.button1);
            this.tabPage5.Controls.Add(this.label13);
            this.tabPage5.Controls.Add(this.label12);
            this.tabPage5.Controls.Add(this.label11);
            this.tabPage5.Controls.Add(this.label10);
            this.tabPage5.Location = new System.Drawing.Point(0, 0);
            this.tabPage5.Name = "tabPage5";
            this.tabPage5.Size = new System.Drawing.Size(240, 225);
            this.tabPage5.Text = "WhereTODO";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(22, 179);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(92, 29);
            this.button2.TabIndex = 15;
            this.button2.Text = "TaskMonitor";
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // label14
            // 
            this.label14.Location = new System.Drawing.Point(3, 112);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(57, 28);
            this.label14.Text = "End Date";
            // 
            // dateTimePicker2
            // 
            this.dateTimePicker2.Format = System.Windows.Forms.DateTimePickerFormat.Short;
            this.dateTimePicker2.Location = new System.Drawing.Point(63, 112);
            this.dateTimePicker2.Name = "dateTimePicker2";
            this.dateTimePicker2.Size = new System.Drawing.Size(170, 22);
            this.dateTimePicker2.TabIndex = 10;
            // 
            // comboBox1
            // 
            this.comboBox1.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Italic);
            this.comboBox1.Items.Add("Chinese Food");
            this.comboBox1.Location = new System.Drawing.Point(63, 86);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(170, 22);
            this.comboBox1.TabIndex = 9;
            // 
            // textBox2
            // 
            this.textBox2.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Italic);
            this.textBox2.Location = new System.Drawing.Point(63, 34);
            this.textBox2.Multiline = true;
            this.textBox2.Name = "textBox2";
            this.textBox2.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBox2.Size = new System.Drawing.Size(170, 46);
            this.textBox2.TabIndex = 3;
            this.textBox2.Text = "Don\'t forget drinks!";
            // 
            // textBox1
            // 
            this.textBox1.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Italic);
            this.textBox1.Location = new System.Drawing.Point(63, 7);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new System.Drawing.Size(170, 21);
            this.textBox1.TabIndex = 2;
            this.textBox1.Text = " e.g. Get Take-Away";
            // 
            // dateTimePicker1
            // 
            this.dateTimePicker1.Format = System.Windows.Forms.DateTimePickerFormat.Time;
            this.dateTimePicker1.Location = new System.Drawing.Point(63, 140);
            this.dateTimePicker1.Name = "dateTimePicker1";
            this.dateTimePicker1.ShowUpDown = true;
            this.dateTimePicker1.Size = new System.Drawing.Size(170, 22);
            this.dateTimePicker1.TabIndex = 1;
            this.dateTimePicker1.Value = new System.DateTime(2008, 8, 28, 0, 0, 0, 0);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(130, 179);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(92, 29);
            this.button1.TabIndex = 8;
            this.button1.Text = "Remind Me";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // label13
            // 
            this.label13.Location = new System.Drawing.Point(3, 140);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(57, 37);
            this.label13.Text = "End Time";
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(3, 86);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(53, 20);
            this.label12.Text = "Place";
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(2, 34);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(54, 20);
            this.label11.Text = "Notes";
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(2, 7);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(58, 27);
            this.label10.Text = "Task Title";
            this.label10.ParentChanged += new System.EventHandler(this.label10_ParentChanged);
            // 
            // status12
            // 
            this.status12.Controls.Add(this.status);
            this.status12.Location = new System.Drawing.Point(0, 0);
            this.status12.Name = "status12";
            this.status12.Size = new System.Drawing.Size(232, 222);
            this.status12.Text = "GPS";
            // 
            // status
            // 
            this.status.Location = new System.Drawing.Point(7, 4);
            this.status.Name = "status";
            this.status.Size = new System.Drawing.Size(226, 208);
            this.status.Text = "Please Wait ...";
            // 
            // tcMap
            // 
            this.tcMap.Controls.Add(this.tabPage5);
            this.tcMap.Controls.Add(this.status12);
            this.tcMap.Controls.Add(this.tabPage6);
            this.tcMap.Location = new System.Drawing.Point(0, 0);
            this.tcMap.Name = "tcMap";
            this.tcMap.SelectedIndex = 0;
            this.tcMap.Size = new System.Drawing.Size(240, 248);
            this.tcMap.TabIndex = 0;
            // 
            // Form1
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
            this.ClientSize = new System.Drawing.Size(240, 268);
            this.Controls.Add(this.tcMap);
            this.Menu = this.mainMenu1;
            this.Name = "Form1";
            this.Text = "Map Point";
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSet)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSetBindingSource)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.wheretodoDataSetBindingSource1)).EndInit();
            this.tabPage6.ResumeLayout(false);
            this.tabPage5.ResumeLayout(false);
            this.status12.ResumeLayout(false);
            this.tcMap.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion
		static void Main() 
		{
			Application.Run(new Form1());
		}

	 /****************************************************/
        //Set Mappoint Web Server Password/Username Here. 
        /****************************************************/
        private string myUserName = "134269";
        private string myPassword = "dolphiN.34";


		private ViewByHeightWidth[]  views = null;
		private FindResults foundAddressResults;
		private LatLong[] latlongs = null;
        private LatLong[] latlongs1 = null;
		private System.Drawing.Bitmap[] m_Maps;
		private int Position=0;

		
        /****************************************************/
        //This is where the GPS code starts. 
        /****************************************************/

        protected void gps_LocationChanged(object sender, LocationChangedEventArgs args)
        {
            position = args.Position;

            // call the UpdateData method via the updateDataHandler so that we
            // update the UI on the UI thread
            Invoke(updateDataHandler);

        }

        void gps_DeviceStateChanged(object sender, DeviceStateChangedEventArgs args)
        {
            device = args.DeviceState;

            // call the UpdateData method via the updateDataHandler so that we
            // update the UI on the UI thread
            Invoke(updateDataHandler);
        }

        void UpdateData(object sender, System.EventArgs args)
        {
            if (gps.Opened)
            {
                string str = "";
                if (device != null)
                {
                    str = device.FriendlyName + " " + device.ServiceState + ", " + device.DeviceState + "\n";
                }

                if (position != null)
                {

                    if (position.LatitudeValid)
                    {
                        str += "Latitude:\n   " + position.Latitude + "\n";
                        //str += "Latitude (D,M,S):\n   " + position.LatitudeInDegreesMinutesSeconds + "\n";
                    }

                    if (position.LongitudeValid)
                    {
                        str += "Longitude:\n   " + position.Longitude + "\n";
                        //str += "Longitude (D,M,S):\n   " + position.LongitudeInDegreesMinutesSeconds + "\n";
                        
                    }

                    if (position.SatellitesInSolutionValid &&
                        position.SatellitesInViewValid &&
                        position.SatelliteCountValid)
                    {
                        str += "Satellite Count:\n   " + position.GetSatellitesInSolution().Length + "/" +
                            position.GetSatellitesInView().Length + " (" +
                            position.SatelliteCount + ")\n";
                    }

                    if (position.TimeValid)
                    {
                        str += "Time:\n   " + position.Time.ToString() + "\n";
                    }
                }

                status.Text = str;

            }
        }

        private void label10_ParentChanged(object sender, EventArgs e)
        {

        }

        private void wheretodoDataSetBindingSource_CurrentChanged(object sender, EventArgs e)
        {

        }
            
        //*********************************************************************************************
        //Create New Task Button
        //*********************************************************************************************

        private void button1_Click(object sender, EventArgs e)
        {
            GC.Collect();
            string connectionString;
            string fileName = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase) + "\\wheretodo.sdf";
            string password = "sa";
            connectionString = string.Format("DataSource=\"{0}\"; Password='{1}'", fileName, password);
            SqlCeConnection cn = new SqlCeConnection(connectionString);
            cn.Open();
            SqlCeCommand cmd;

            OutlookSession outlooksession = new OutlookSession();
            Task NewTask = new Task();
            NewTask.Body = textBox2.Text.ToString();
            
            string MyString = dateTimePicker2.Value.ToShortDateString() + " " + dateTimePicker1.Text.ToString();
            DateTime MyDateTime = new DateTime();
            MyDateTime = DateTime.ParseExact(MyString, "M/d/yy h:mm:ss tt", null);

            NewTask.DueDate = MyDateTime.ToUniversalTime();
            NewTask.Subject = textBox1.Text.ToString();
            outlooksession.Tasks.Items.Add(NewTask);

            string sql = "Insert into WhereToDo2 (Task_Title,Task_Keyword,Task_DateTime,Task_Notes, Pim_ID) values(@Title, @Place, @DateTime, @Notes, '" + NewTask.ItemId.ToString() +"')";  
            cmd = new SqlCeCommand(sql, cn);
            cmd.Parameters.Add("@Title", SqlDbType.NVarChar, 255, "Title").Value = textBox1.Text.ToString();
            cmd.Parameters.Add("@Place", SqlDbType.NVarChar, 255, "Place").Value = comboBox1.Text.ToString();
            cmd.Parameters.Add("@DateTime", SqlDbType.DateTime, 255, "DateTime").Value = dateTimePicker2.Value.ToShortDateString() + " " + dateTimePicker1.Text.ToString();
            cmd.Parameters.Add("@Notes", SqlDbType.NVarChar, 255, "Notes").Value = textBox2.Text.ToString();
            
            cmd.ExecuteNonQuery();
        }

        //*******************************************************************
        //This function monitors the current tasks and if the geographic surroundings
        //have a solution defined by a point of interest
        //******************************************************************

        private void GPSInformedTaskUpdater()
        {
            while (true)
            {
                GC.Collect();
                string connectionString;
                
                string fileName = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase) + "\\wheretodo.sdf";
                string password = "sa";
                connectionString = string.Format("DataSource=\"{0}\"; Password='{1}'", fileName, password);
                SqlCeConnection cn = new SqlCeConnection(connectionString);
                cn.Open();
                SqlCeCommand cmd;
                string sql = "Select * from WhereToDo2";
                cmd = new SqlCeCommand(sql, cn);
                SqlCeResultSet DB_Tasks = cmd.ExecuteResultSet(ResultSetOptions.Scrollable);

                LatLong LatLong1 = GetLatLong();

                //Testing values (values set for London, UK)
                double Lat = 51.5002;
                double Long = -0.1262;
                //LatLong1.Latitude = Lat;
                //LatLong1.Longitude = Long;
                LatLong1.Latitude = LatLong1.Latitude;
                LatLong1.Longitude = LatLong1.Longitude;

                //Are there tasks to be monitored
                if (DB_Tasks.HasRows)
                {
                    while (DB_Tasks.Read())
                    {
                        int ordKeyWord = DB_Tasks.GetOrdinal("Task_Keyword");
                        int ordPimID = DB_Tasks.GetOrdinal("Pim_ID");

                        //Check within GeoCacheLog for previous searches
                        SqlCeCommand cmd2;
                        string sql2 = "Select * from GeoCodeLog where Keyword = '" + "FoodType3" + "'";
                        cmd2 = new SqlCeCommand(sql2, cn);

                        SqlCeResultSet DB_GeoCodeLog = cmd2.ExecuteResultSet(ResultSetOptions.Scrollable);

                        //Has a search with the keyword been issued before
                        if (DB_GeoCodeLog.HasRows)
                        {
                            int ordLat = DB_GeoCodeLog.GetOrdinal("Lat");
                            int ordLong = DB_GeoCodeLog.GetOrdinal("Long");
                            int ordTask = DB_GeoCodeLog.GetOrdinal("Search_ID");
                            int flag = 0;

                            while (DB_GeoCodeLog.Read())
                            {
                                //if Lat long pair of past keyword searches is less than a given distance
                                //don't populate geocache with existing information
                                
                                double POI_Lat = Convert.ToDouble((string)DB_GeoCodeLog.GetSqlString(ordLat));
                                double POI_Long = Convert.ToDouble((string)DB_GeoCodeLog.GetSqlString(ordLong));

                                if (GetLatLongTuppleDistance(POI_Lat, POI_Long, Lat, Long) < (Convert.ToDouble(inputdistance.Text)/2))
                                {
                                    flag++;
                                    break;
                                }
                            }
                            if (flag > 0)
                            {
                                GetNearByPOI("FoodType3", LatLong1);
                            }
                        }
                        else
                        {
                            GetNearByPOI("FoodType3", LatLong1);
                        }


                        //FOR EACH TASK LOOK FOR LOCAL SOLUTIONS-------------------------------------

                        //SqlCeCommand cmd3;
                        string sql3 = "Select * from GeoCache2 where POI_KeyWord = '" + "FoodType3" + "'";
                        //cn.Open();
                        cmd = new SqlCeCommand(sql3, cn);

                        SqlCeResultSet DB_GeoCode = cmd.ExecuteResultSet(ResultSetOptions.Scrollable);

                        //For each entry in the GeoCache that matches the Keyword
                        //If GPS location --> Keyword --> POI adjust task using ID to now so
                        //an alert is fired

                        if (DB_GeoCode.HasRows)
                        {
                            // Use the get ordinal function so you dont 
                            // have to worry about remembering what 
                            // order your SQL put the field names in. 
                            
                            int ordLat1 = DB_GeoCode.GetOrdinal("POI_Lat");
                            int ordLong1 = DB_GeoCode.GetOrdinal("POI_Long");
                            int ordTask1 = DB_GeoCode.GetOrdinal("POI_ID");
                            int ordName = DB_GeoCode.GetOrdinal("POI_Name");
                            int ordAddress = DB_GeoCode.GetOrdinal("POI_Address");

                            while (DB_GeoCode.Read())
                            {
                                //Check the distance long lat if so trigger alert

                                double ordLat2 = Convert.ToDouble((string)DB_GeoCode.GetSqlString(ordLat1));
                                double ordLong2 = Convert.ToDouble((string)DB_GeoCode.GetSqlString(ordLong1));
                                string ordPOIName = (string)DB_GeoCode.GetSqlString(ordName);
                                string ordPOIAddress = (string)DB_GeoCode.GetSqlString(ordAddress);
                               

                                if (GetLatLongTuppleDistance(ordLat2, ordLong2, Lat, Long) < 50)
                                {
                                    TriggerTask(DB_Tasks.GetString(ordPimID), ordPOIName, ordPOIAddress);
                                }
                            }

                        }


                    }

                    //END -----------------------------------------------


                    }                    
            }
        }

        //This function gets the current LatLong position in terms of a 
        //LatLong object from the GPS reciever
        private LatLong GetLatLong()
        {
            LatLong CurrentLatLongPos = new LatLong();
            if (gps.Opened)
            {
                if (position != null)
                {
                    if (position.LatitudeValid) CurrentLatLongPos.Latitude = position.Latitude;
                    if (position.LongitudeValid) CurrentLatLongPos.Longitude = position.Longitude;
                }
            }

            return CurrentLatLongPos;
        }


        //This function gets all POI using the keyword within the set distance from
        //the current LatLong and loads them into the GeoCache
        private void GetNearByPOI(string KeyWord, LatLong CurrentPosition)
        {

            FindServiceSoap findService = new FindServiceSoap();
            FindNearbySpecification findNearBySpec = new FindNearbySpecification();
            findService.Credentials = new System.Net.NetworkCredential(myUserName, myPassword);
            findService.PreAuthenticate = true;

            findNearBySpec.Distance = Convert.ToDouble(inputdistance.Text);
            findNearBySpec.LatLong = new LatLong();
            findNearBySpec.LatLong.Latitude = CurrentPosition.Latitude;
            findNearBySpec.LatLong.Longitude = CurrentPosition.Longitude;

            findNearBySpec.Filter = new FindFilter();
            //findNearBySpec.Filter.EntityTypeName = "FoodType3";
            findNearBySpec.Filter.EntityTypeName = KeyWord;
            findNearBySpec.DataSourceName = "NavTech.EU";

            FindResults foundResults;
            foundResults = findService.FindNearby(findNearBySpec);

            string connectionString;
            string fileName = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase) + "\\wheretodo.sdf";
            string password = "sa";
            connectionString = string.Format("DataSource=\"{0}\"; Password='{1}'", fileName, password);
            SqlCeConnection cn = new SqlCeConnection(connectionString);
            cn.Open();
            SqlCeCommand cmd;
           
            //Loop Round and add it to the GeoCache
            foreach (FindResult fr in foundResults.Results)
            {
                //This needs to include LongLat in GeoCache
                string sql = "insert into GeoCache2 (POI_Name, POI_Address, POI_Tel, POI_Web, POI_POST_ZIP, POI_Lat, POI_Long, POI_KeyWord) values (@Name, @Address, @Tel, @Web, @POST_ZIP, '" + fr.FoundLocation.LatLong.Latitude.ToString() + "', '" + fr.FoundLocation.LatLong.Longitude.ToString() + "', '" + KeyWord.ToString() + "')";
                cmd = new SqlCeCommand(sql, cn);
                cmd.Parameters.Add("@Name", SqlDbType.NVarChar, 255, "Name").Value = fr.FoundLocation.Entity.Properties[0].Value.ToString();
                cmd.Parameters.Add("@Address", SqlDbType.NVarChar, 255, "Address").Value = fr.FoundLocation.Entity.Properties[1].Value.ToString() + fr.FoundLocation.Entity.Properties[2].Value.ToString();
                cmd.Parameters.Add("@Tel", SqlDbType.NVarChar, 255, "Tel").Value = fr.FoundLocation.Entity.Properties[9].Value.ToString();
                cmd.Parameters.Add("@Web", SqlDbType.NVarChar, 255, "Web").Value = "http://m.live.com";
                cmd.Parameters.Add("@POST_ZIP", SqlDbType.NVarChar, 255, "POST_ZIP").Value = fr.FoundLocation.Entity.Properties[7].Value.ToString();
                cmd.ExecuteNonQuery();

                //Update GeoCacheLog
                sql = "insert into GeoCodeLog (Keyword, Lat, Long ) values ('" + KeyWord + "', '" + fr.FoundLocation.LatLong.Latitude.ToString() + "', '" + fr.FoundLocation.LatLong.Longitude.ToString() + "' )";
                cmd = new SqlCeCommand(sql, cn);
                cmd.ExecuteNonQuery();

            }

        }

        //This function calculates the direct line distance (km) between two pairs of lat long
        private double GetLatLongTuppleDistance(double Lat1, double Long1, double Lat2, double Long2)
        {
            //Convert Degress to Radians for Calculations
            double Lat1r = ConvertDegreesToRadians(Lat1);
            double Lat2r = ConvertDegreesToRadians(Lat2);
            double Long1r = ConvertDegreesToRadians(Long1);
            double Long2r = ConvertDegreesToRadians(Long2);

            // Spherical law of cosines formula - ignores the effect of hills
            double R = 6371; // Earths radius (km)
            double d = Math.Acos(Math.Sin(Lat1r) * Math.Sin(Lat2r) +
                              Math.Cos(Lat1r) * Math.Cos(Lat2r) *
                              Math.Cos(Long2r - Long1r)) * R;

            //Returns distances in km
            return d;
        }

        public static double ConvertDegreesToRadians(double degrees)
        {
            double radians = (Math.PI / 180) * degrees;
            return (radians);
        }  

        private bool TriggerTask(string TaskID, string val1, string val2)
        {
            //Find task by ID and updates its status to be triggered now. 
            OutlookSession outlooksession = new OutlookSession();

            for (int i = 0; i < outlooksession.Tasks.Items.Count; i++)
            {
                if (outlooksession.Tasks.Items[i].ItemId.ToString() == TaskID)
                {
                    outlooksession.Tasks.Items[i].Body = outlooksession.Tasks.Items[i].Body + " ," + val1 + " ," + val2;
                    outlooksession.Tasks.Items[i].ShowDialog();
                    MessageBox.Show(outlooksession.Tasks.Items[i].Subject + ": " + outlooksession.Tasks.Items[i].Body + " ," + val1 + " ," + val2);
                    outlooksession.Tasks.Items[i].Delete();
                }                
            }

            return true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            GPSInformedTaskUpdater();
        }

	}
}
